#include "GuiInfo.h"
#include "Debug.h"
#include "Resource.h"
#include <CommCtrl.h>

void LockCursor(HWND hWnd)
{
	RECT rcMap, rcClip;
	POINT upperLeft, lowerRight;
	upperLeft.x = 0;
	upperLeft.y = 0;

	GetClientRect(hWnd, &rcMap);
	lowerRight.x = rcMap.right-1;
	lowerRight.y = rcMap.bottom-1;

	ClientToScreen(hWnd, &upperLeft);
	ClientToScreen(hWnd, &lowerRight);

	rcClip.left = upperLeft.x;
	rcClip.top = upperLeft.y;
	rcClip.bottom = lowerRight.y;
	rcClip.right = lowerRight.x;

	ClipCursor(&rcClip);
}

// MDI-Map-Window(s) stuff

HWND AddMDIChild(HWND hClient, char* name)
{
	return CreateMDIWindowA("MdiChild", name, WS_MAXIMIZE,
							CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
							hClient, GetModuleHandle(NULL), 0);
}

BITMAPINFO GetBMI(long width, long height)
{
	BITMAPINFOHEADER bmiH = { };
	bmiH.biSize = sizeof(BITMAPINFOHEADER);
	bmiH.biWidth = width; bmiH.biHeight = -height;
	bmiH.biPlanes = 1;
	bmiH.biBitCount = 24;
	bmiH.biCompression = BI_RGB;
	bmiH.biXPelsPerMeter = 1; bmiH.biYPelsPerMeter = 1;
					
	BITMAPINFO bmi = { };
	bmi.bmiHeader = bmiH;
	return bmi;
}

LPBITMAPINFO GetPalBMI(long width, long height)
{
	BITMAPINFOHEADER bmiH = { };
	bmiH.biSize = sizeof(BITMAPINFOHEADER);
	bmiH.biWidth = width; bmiH.biHeight = -height;
	bmiH.biPlanes = 1;
	bmiH.biBitCount = 32;
	bmiH.biClrUsed = 256;
	bmiH.biClrImportant = 256;
	bmiH.biCompression = BI_RGB;
	bmiH.biXPelsPerMeter = 1; bmiH.biYPelsPerMeter = 1;
					
	char* cBmi = new char[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)*256];
	LPBITMAPINFO bmi = (LPBITMAPINFO)cBmi;
	bmi->bmiHeader = bmiH;
	return bmi;
}

OPENFILENAME GetSaveOfn(char* szFileName)
{
	OPENFILENAME ofn = { };
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFilter = "Starcraft Map(*.scm)\0*.scm\0Starcraft Hybrid Map(*.scm)\0*.scm\0Broodwar Map(*.scx)\0*.scx\0Raw Starcraft Map(*.chk)\0*.chk\0Raw Starcraft Hybrid Map(*.chk)\0*.chk\0Raw Broodwar Map(*.chk)\0*.chk\0";
	ofn.lpstrFile = szFileName;
	ofn.nFilterIndex = 2;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	return ofn;
}

// List View stuff

void AddColumn(HWND hListView, int insertAt, char* title, int width, int flags)
{
	LV_COLUMN lvCol = { };
	lvCol.mask = LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM|LVCF_ORDER;
	lvCol.fmt = flags;
	lvCol.cx = width;
	lvCol.iSubItem = insertAt+1;
	lvCol.pszText = title;
	lvCol.cchTextMax = sizeof(title);
	lvCol.iOrder = insertAt;

	ListView_InsertColumn(hListView, insertAt, &lvCol);
}

void AddRow(HWND hListView, int numColumns, LPARAM lParam)
{
	LVITEM item = { };
	item.mask = LVIF_COLUMNS|LVIF_PARAM;
	item.cColumns = numColumns;
	item.lParam = lParam;

	ListView_InsertItem(hListView, &item);
}

void SetItem(HWND hListView, int row, int column, char* text)
{
	LVITEM subItem = { };
	subItem.mask = LVIF_TEXT;
	subItem.iItem = row;
	subItem.pszText = text;
	subItem.cchTextMax = strlen(text);
	subItem.iSubItem = column;

	ListView_SetItem(hListView, &subItem);
}