﻿#ifndef GUIINTERFERENCE_H
#define GUIINTERFERENCE_H
#include <Windows.h>
#include <CommCtrl.h>

void LockCursor(HWND hWnd);

// MDI-Map-Window(s) stuff

HWND AddMDIChild(HWND hClient, char* Name);

BITMAPINFO GetBMI(long width, long height);
LPBITMAPINFO GetPalBMI(long width, long height);
OPENFILENAME GetSaveOfn(char* szFileName);

// List View stuff

void AddColumn(HWND hListView, int insertAt, char* title, int width, int flags);
void AddRow(HWND hListView, int numColumns, LPARAM lParam);
void SetItem(HWND hListView, int row, int column, char* text);

// Tree View stuff

struct TreeView
{
	int numItems;
	HTREEITEM TreePtr[228];
	int UnitID[228];
};

extern TV_INSERTSTRUCT doodads;

extern TreeView DefaultTree;

extern char* Units_Zerg_Misc[6];
extern char* Units_Zerg_Air[6];
extern char* Units_Zerg_Buildings[17];
extern char* Units_Zerg_Ground[8];
extern char* Units_Zerg_Heroes[10];
extern char* Units_Zerg_Special[3];
extern char* Units_Zerg_SpecialBuildings[6];
extern char* Units_Zerg_Zerg[2];
extern char* Units_Terran_Misc[8];
extern char* Units_Terran_Addons[6];
extern char* Units_Terran_Air[5];
extern char* Units_Terran_Buildings[12];
extern char* Units_Terran_Ground[9];
extern char* Units_Terran_Heroes[16];
extern char* Units_Terran_Special[5];
extern char* Units_Terran_SpecialBuildings[4];
extern char* Units_Terran_Terran[1];
extern char* Units_Protoss_Air[7];
extern char* Units_Protoss_Buildings[16];
extern char* Units_Protoss_Ground[9];
extern char* Units_Protoss_Heroes[13];
extern char* Units_Protoss_Protoss[2];
extern char* Units_Protoss_Special[3];
extern char* Units_Protoss_SpecialBuildings[5];
extern char* Units_Neutral_Critters[6];
extern char* Units_Neutral_Doodads[11];
extern char* Units_Neutral_Neutral[7];
extern char* Units_Neutral_Powerups[6];
extern char* Units_Neutral_Protoss[1];
extern char* Units_Neutral_Resources[12];
extern char* Units_Neutral_Special[2];
extern char* Units_Neutral_StartLocation[1];
extern char* Units_Neutral_Zerg[1];
extern char* Units_Independent[2];

void DefaultTreeNames();

TV_INSERTSTRUCT InsertItems(HWND hWnd, TV_INSERTSTRUCT tvinsert, char** items, int amount);

HTREEITEM InsertGroup(HWND hWnd, TV_INSERTSTRUCT tvinsert, char* pszText, HTREEITEM LastGroup);

TV_INSERTSTRUCT InsertChild(HWND hWnd, TV_INSERTSTRUCT tvinsert, char* pszText);

TV_INSERTSTRUCT InsertParent(HWND hWnd, TV_INSERTSTRUCT tvinsert, char* pszText);

void BuildTree(HWND hWnd);

void UpdateTreeItemText(HWND hWnd, int UnitID);

void changeDisplayName(HWND hWnd, int UnitID, char* name);

#endif