#ifndef MAP_H
#define MAP_H
#include <Windows.h>
#include <string>
#include "Buffer.h"

extern struct Unit;
#define UNIT_STRUCT_SIZE 36

class GRID
{
	public:
		POINTS size;
		POINT offset;
		BYTE red;
		BYTE green;
		BYTE blue;

		GRID() : red(0), green(0), blue(0) { size.x = 0; size.y = 0; offset.x = 0; offset.y = 0; }
};

class section
{
	public:
		buffer buf;
		section* next;
	
		section(char *title) : buf(title) { }
};

class MAP
{
	public:
		HWND hWnd;
		char filename[MAX_PATH];
		BYTE SaveType;
		BYTE layer;
		BYTE player;
		double zoom;

		POINT display;
		GRID grids[2];

		char* lpvBits;
		USHORT bitWidth;
		USHORT bitHeight;
		HDC MemhDC;
		HDC MemMinihDC;
		HBITMAP MemBitmap;
		HBITMAP MemMiniBitmap;

		bool isProtected;
		bool RedrawMiniMap;
		bool RedrawMap;
		bool dragging;

		section* head; // Linked list of sections

		// Pointers to section buffers used by Chkdraft
		buffer* TYPE;	buffer* VER ;	buffer* IVER;	buffer* IVE2;
		buffer* VCOD;	buffer* IOWN;	buffer* OWNR;	buffer* ERA ;
		buffer* DIM ;	buffer* SIDE;	buffer* MTXM;	buffer* PUNI;
		buffer* UPGR;	buffer* PTEC;	buffer* UNIT;	buffer* ISOM;
		buffer* TILE;	buffer* DD2 ;	buffer* THG2;	buffer* MASK;
		buffer* STR ;	buffer* UPRP;	buffer* UPUS;	buffer* MRGN;
		buffer* TRIG;	buffer* MBRF;	buffer* SPRP;	buffer* FORC;
		buffer* WAV ;	buffer* UNIS;	buffer* UPGS;	buffer* TECS;
		buffer* SWNM;	buffer* COLR;	buffer* PUPx;	buffer* PTEx;
		buffer* UNIx;	buffer* UPGx;	buffer* TECx;

		MAP();
		~MAP();

		bool RemoveSection(section* sect);
		bool RemoveSection(buffer* buf);

		void UpdatePtrs();
		bool GoodVCOD();
		bool ParseBuffer(buffer &chk);
		bool CreateNew(int width, int height, int tileset, int terrain, int triggers);
		bool LoadFile(HWND hWnd);
		bool SaveFile(HWND hWnd, bool SaveAs);
		void WriteFile(FILE* pFile);

		void setZoom(double newScale);
		void Scroll(UINT flags);
		void ValidateBorder(int screenWidth, int screenHeight);

		unsigned short XSize();
		unsigned short YSize();
		bool isExpansion();
		Unit* unit(unsigned short index);
		buffer* unitSettings();
		float Scale(unsigned short xSize, unsigned short ySize);

		bool SetTile(long x, long y, unsigned short tileNum);
};

#endif